#include <stdio.h>

unsigned char data3d[75497472];

//change l'endian d'un nombre
unsigned short endian_swap16(unsigned short nombre){
	return nombre<<8|nombre>>8;
}

unsigned int endian_swap32(unsigned int nombre){
	return nombre<<24|nombre<<16>>24<<16|nombre<<8>>24<<8|nombre>>24;
}

/*dans staidx.mul, on sort (unsigned int deplacement,unsigned int taille) (2*32bits)

si deplacement different de 0xffffffff
on se deplace ensuite dans lseek(staticsmul,deplacement,SEEK_SET) (SEEK_SET : debut)
dans statics.mul, on sort (unsigned short color,char x,char y,char alti) (tous les 7 octets)
si is_static vrai on change si alti >= block.static_alti
si is_static faux on met is_static a vrai et on change
bloc[ax+by].couleur_static=color+16384
bloc[ax+by].alti_static=alti
*/

int main(void){
	int j,l,k;
	unsigned short tabcouleur[65536];
	unsigned short couleurid,blabla;
	char i[18432];

	FILE *fichin,*fichout,*couleurmul,*staid,*statics;
	
	
	couleurmul=fopen("radarcol.mul","r");
	for(j=0;j<65536;j++){
		fread(&tabcouleur[j],2,1,couleurmul);
	}
	fclose(couleurmul);
	
	fichin=fopen("data.u3d","r");
	for(j=0;j<4096;j++){
		fread(i,18432,1,fichin);
		memcpy(data3d+18432*j,i,18432);
	}
	fclose(fichin);
	staid=fopen("staidx0.mul","r");
	statics=fopen("statics0.mul","r");
	for(k=0;k<393216;k++){
		int offset,taille,bla;
		fread(&offset,4,1,staid);
		fread(&taille,4,1,staid);
		fread(&bla,4,1,staid);
		if(offset!=-1){//il y a des static, on va modifier le map
			fprintf(stderr,"%d/393216\n",k);
			fseek(statics,offset,SEEK_SET);
			for(l=0;l<taille;l+=7){
				char x,y,alti,origalti;
				fread(&couleurid,2,1,statics);
				fread(&x,1,1,statics);
				fread(&y,1,1,statics);
				fread(&alti,1,1,statics);
				fread(&blabla,2,1,statics);
				origalti=data3d[((k%512*8+y)*6144+k/512*8+x)*3+2];
				if(origalti<=alti){
					//couleurid=endian_swap16(couleurid);
					couleurid=tabcouleur[couleurid+16384];
					//couleurid=endian_swap16(couleurid);
					data3d[((k%512*8+y)*6144+k/512*8+x)*3]=couleurid>>8;
					data3d[((k%512*8+y)*6144+k/512*8+x)*3+1]=couleurid<<8>>8;
					data3d[((k%512*8+y)*6144+k/512*8+x)*3+2]=alti;
				}
			}
		}
	}
	fichout=fopen("datas.u3d","w");
	for(j=0;j<4096;j++){
		memcpy(i,data3d+18432*j,18432);
		fwrite(i,18432,1,fichout);
	}
	fclose(fichout);
	return 0;
}