#include <stdio.h>

typedef struct{
	unsigned short couleur;
	char alti;
	char is_static;
} bloc;

//change l'endian d'un nombre
unsigned short endian_swap16(unsigned short nombre){
	return nombre<<8|nombre>>8;
}

unsigned int endian_swap32(unsigned int nombre){
	return nombre<<24|nombre<<16>>24<<16|nombre<<8>>24<<8|nombre>>24;
}

/*dans staidx.mul, on sort (unsigned int deplacement,unsigned int taille) (2*32bits)

si deplacement different de 0xffffffff
on se deplace ensuite dans lseek(staticsmul,deplacement,SEEK_SET) (SEEK_SET : debut)
dans statics.mul, on sort (unsigned short color,char x,char y,char alti) (tous les 7 octets)
si is_static vrai on change si alti >= block.static_alti
si is_static faux on met is_static a vrai et on change
bloc[ax+by].couleur_static=color+16384
bloc[ax+by].alti_static=alti
*/

int main(int argc,char **argv){
	int i,j,k;
	unsigned short tabcouleur[65536];
	unsigned short couleurid;
	char alti;

	FILE *fichout,*mapmul,*couleurmul;
	
	fichout=fopen("data.u3d","w");
	
	couleurmul=fopen("radarcol.mul","r");
	for(i=0;i<65536;i++){
		fread(&tabcouleur[i],2,1,couleurmul);
	}
	fclose(couleurmul);
	
	mapmul=fopen("map0.mul","r");
	for(j=0;j<4096;j++){
		for(i=0;i<6144;i+=8){
			fseek(mapmul,4+196*((i/8*512)+j/8)+j%8*24,SEEK_SET);
			for(k=0;k<8;k++){
				fread(&couleurid,2,1,mapmul);
				fread(&alti,1,1,mapmul);
				
				couleurid=tabcouleur[couleurid];
				couleurid=endian_swap16(couleurid);
				
				fwrite(&couleurid,2,1,fichout);
				fwrite(&alti,1,1,fichout);
			}
		}
		fprintf(stderr,"%d/4096\n",j);
	}
	fclose(mapmul);
	fclose(fichout);
	return 0;
}