#include <stdio.h>
#include <GL/glut.h>

int xdeb=1294,ydeb=1552;
char presse_g,presse_d;
int pas=1,zoom=1;
int anglex=0,angley=0,x,y,xold,yold,dist=100,hauteur=-10;


unsigned char data3d[75497472];

//change l'endian d'un nombre
unsigned short endian_swap16(unsigned short nombre){
	return nombre<<8|nombre>>8;
}

unsigned int endian_swap32(unsigned int nombre){
	return nombre<<24|nombre<<16>>24<<16|nombre<<8>>24<<8|nombre>>24;
}

//convertit la couleur de 5 vers 8 bits
unsigned char couleur_r(unsigned short couleur){
	return couleur<<1>>11<<3;
}

unsigned char couleur_g(unsigned short couleur){
	return couleur<<6>>11<<3;
}

unsigned char couleur_b(unsigned short couleur){
	return couleur<<11>>11<<3;
}

//fonctions de rappel glut
void affichage(){
	int i,j;
	
	//effacement
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();

	glScalef(100.0/dist,100.0/dist,100.0/dist);
	glRotatef(-angley,1.0,0.0,0.0);
	glRotatef(-anglex,0.0,0.0,1.0);
	glTranslatef(0.0,0.0,hauteur);
	
	//dessin
	for(j=ydeb;j<ydeb+150*zoom;j+=pas*zoom){
		for(i=xdeb;i<xdeb+150*zoom;i+=pas*zoom){
			unsigned short couleur[4]={0,0,0,0};
			char alti[4]={0,0,0,0};
			if((6144*j+(i+pas*zoom))*3+2<75497472){
				couleur[0]=data3d[(6144*j+(i+pas*zoom))*3]<<8|data3d[(6144*j+(i+pas*zoom))*3+1];
				alti[0]=data3d[(6144*j+(i+pas*zoom))*3+2];
			}
			if((6144*j+i)*3+2<75497472){
				couleur[1]=data3d[(6144*j+i)*3]<<8|data3d[(6144*j+i)*3+1];
				alti[1]=data3d[(6144*j+i)*3+2];
			}
			if((6144*(j+pas*zoom)+i)*3+2<75497472){
				couleur[2]=data3d[(6144*(j+pas*zoom)+i)*3]<<8|data3d[(6144*(j+pas*zoom)+i)*3+1];
				alti[2]=data3d[(6144*(j+pas*zoom)+i)*3+2];
			}
			if((6144*(j+pas*zoom)+(i+pas*zoom))*3+2<75497472){
				couleur[3]=data3d[(6144*(j+pas*zoom)+(i+pas*zoom))*3]<<8|data3d[(6144*(j+pas*zoom)+(i+pas*zoom))*3+1];
				alti[3]=data3d[(6144*(j+pas*zoom)+(i+pas*zoom))*3+2];
			}
			
			
			glBegin(GL_POLYGON);
			glColor3ub(couleur_r(couleur[0]),couleur_g(couleur[0]),couleur_b(couleur[0]));
			glVertex3i((i-xdeb)/zoom+pas-75,(j-ydeb)/zoom-75,alti[0]/3/zoom);
			glColor3ub(couleur_r(couleur[1]),couleur_g(couleur[1]),couleur_b(couleur[1]));
			glVertex3i((i-xdeb)/zoom-75,(j-ydeb)/zoom-75,alti[1]/3/zoom);
			glColor3ub(couleur_r(couleur[2]),couleur_g(couleur[2]),couleur_b(couleur[2]));
			glVertex3i((i-xdeb)/zoom-75,(j-ydeb)/zoom+pas-75,alti[2]/3/zoom);
			glColor3ub(couleur_r(couleur[3]),couleur_g(couleur[3]),couleur_b(couleur[3]));
			glVertex3i((i-xdeb)/zoom+pas-75,(j-ydeb)/zoom+pas-75,alti[3]/3/zoom);
			glEnd();
		}
	}
	glPopMatrix();
	
	glFlush();
	glutSwapBuffers();
}

void clavier(unsigned char touche,int x,int y){
	if(touche==56){
		ydeb-=10*zoom;
		if(ydeb<0)
			ydeb=0;
		glutPostRedisplay();
	}
	else if(touche==50){
		ydeb+=10*zoom;
		if(ydeb>4095)
			ydeb=4095;
		glutPostRedisplay();
	}
	else if(touche==52){
		xdeb-=10*zoom;
		if(xdeb<0)
			xdeb=0;
		glutPostRedisplay();
	}
	else if(touche==54){
		xdeb+=10*zoom;
		if(xdeb>6143)
			xdeb=6143;
		glutPostRedisplay();
	}
	else if(touche=='r'){
		pas=1;zoom=1;
		anglex=0;angley=0;
		dist=100;hauteur=-10;
		glutPostRedisplay();
	}
	else if(touche=='m'){
		pas*=2;
		if(pas>16)
			pas=16;
		glutPostRedisplay();
	}
	else if(touche=='p'){
		pas/=2;
		if(pas<1)
			pas=1;
		glutPostRedisplay();
	}
	else if(touche=='o'){
		hauteur-=10;
		glutPostRedisplay();
	}
	else if(touche=='l'){
		hauteur+=10;
		glutPostRedisplay();
	}
	else if(touche=='i'){
		zoom-=1;
		if(zoom<1)
			zoom=1;
		glutPostRedisplay();
	}
	else if(touche=='k'){
		zoom+=1;
		glutPostRedisplay();
	}
	else if(touche=='u'){
		glPolygonMode(GL_FRONT,GL_FILL);
		glutPostRedisplay();
	}
	else if(touche=='j'){
		glPolygonMode(GL_FRONT,GL_LINE);
		glutPostRedisplay();
	}
	else if(touche=='q'||touche==27){
		exit(0);
	}
	else
		fprintf(stderr,"Catch! %d\n",touche);
}
void mouse(int button, int state,int x,int y)
{
  /* si on appuie sur le bouton gauche */
  if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) 
  {
    presse_g = 1; /* le booleen presse passe a 1 (vrai) */
    xold = x; /* on sauvegarde la position de la souris */
    yold=y;
  }
  /* si on relache le bouton gauche */
  if (button == GLUT_LEFT_BUTTON && state == GLUT_UP) 
    presse_g=0; /* le booleen presse passe a 0 (faux) */

  if (button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN) 
  {
    presse_d = 1; /* le booleen presse passe a 1 (vrai) */
    xold = x; /* on sauvegarde la position de la souris */
    yold=y;
  }
  /* si on relache le bouton gauche */
  if (button == GLUT_RIGHT_BUTTON && state == GLUT_UP) 
    presse_d=0; /* le booleen presse passe a 0 (faux) */
}

void mousemotion(int x,int y)
  {
    if (presse_g) /* si le bouton gauche est presse */
    {
      /* on modifie les angles de rotation de l'objet
	 en fonction de la position actuelle de la souris et de la derniere
	 position sauvegardee */
      anglex=anglex+(x-xold); 
      angley=angley+(y-yold);
      glutPostRedisplay(); /* on demande un rafraichissement de l'affichage */
    }
    else if (presse_d) /* si le bouton gauche est presse */
    {
      /* on modifie les angles de rotation de l'objet
	 en fonction de la position actuelle de la souris et de la derniere
	 position sauvegardee */
      dist=dist-(y-yold);
		if(dist<1)
			dist=1;
      glutPostRedisplay(); /* on demande un rafraichissement de l'affichage */
    }
    
    xold=x; /* sauvegarde des valeurs courante de le position de la souris */
    yold=y;
  }

int main(int argc,char **argv){
	FILE *datafile;
	char i[18432];
	int j;
	
	datafile=fopen("datas.u3d","r");
	for(j=0;j<4096;j++){
		fread(i,18432,1,datafile);
		memcpy(data3d+18432*j,i,18432);
	}
	
	//init glut
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_RGBA|GLUT_DOUBLE|GLUT_DEPTH);
	glutInitWindowPosition(0,0);
	glutInitWindowSize(600,600);
	glutCreateWindow("UOGLMap");

	//init openGL
	glViewport(0,0,600,600);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glClearColor(0.0,0.0,0.0,0.0);
	glOrtho(-75.0,75.0,75.0,-75.0,-600.0,600.0);
	glEnable(GL_DEPTH_TEST);
	glCullFace(GL_BACK);
	glEnable(GL_CULL_FACE);

	//fonctions de rappel
	glutDisplayFunc(affichage);
	glutKeyboardFunc(clavier);
	glutMouseFunc(mouse);
	glutMotionFunc(mousemotion);


	//boucle principale glut
	glutMainLoop();
	return 0;
}